// Exemple de code pour faire fonctionner la station météo proposée par Vigie-Nature École


/* 1ere Partie du code, définition des variables et appelle des bibliothèques externes */

#include "DHT.h"        // inclure une bibliothèque pour faire fonctionner le capteur d'humidité et de température (le DHT 22)
#define DHTTYPE DHT22   // On dit qu'on utilise la version DHT 22  (AM2302)
#define DHTPIN 2       // Les données du capteur d'humidité et de températureearrivent sur la pin 2

DHT dht(DHTPIN, DHTTYPE);

#define SOLPIN A0    // Les données du capteur d'humidité du sol arrivent sur la pin A0
#define LUMPIN A1    // Les données du capteur de luminosité arrivent sur la pin A1
#define PLUIEPIN A2  // Les données du capteur de luminosité arrivent sur la pin A2

/* 2nde Partie du code, initialisation de la carte */

void setup() {
  Serial.begin(9600); 
  dht.begin();
}

/* 3eme Partie du code, réupération des mesures */
void loop() {
  
// Partie du code pour récupérer les données spécifiques au capteur d'humidité et de température

  float h = dht.readHumidity();    // On crée un nombre à virgule qui correspond a la valeur mesurée pour l'humidité
  float t = dht.readTemperature(); // On crée un nombre à virgule qui correspond a la valeur mesurée pour la température
 
  // On vérifie que le capteur fonctionne correctement, si c'est le cas, partie située après le "else", on affiche les mesures.
  if (isnan(t) || isnan(h)) {
    Serial.println("Impossible de lire le capteur DHT, verifier son branchement...");
    } else {
    Serial.print("Humidite : ");   // Affiche à l'écran ce qui est entre ""
    Serial.print(h);               // Affiche à la suite la mesure d'humidité
    Serial.println(" %\t");        // Affiche à la suite "%", puis saute une ligne
    Serial.print("Temperature: "); // Affiche à l'écran ce qui est entre ""
    Serial.print(t);               // Affiche à la suite la mesure de température
    Serial.println(" *C");         // Affiche à la suite "C", puis saute une ligne
  }


  
  
  // Partie du code pour récupérer les données spécifiques au capteur d'humidité du sol
  
  int sol = analogRead(SOLPIN);                // On créer un nombre entier qui correspond au chiffre obtenu par le capteur sol banché à l'endrois défini au début du code
  Serial.print("Valeur mesuree = ");      // On affiche ce qui est entre ""
  Serial.print(sol); Serial.print(" - ");  // On affiche ce chiffre suivi d'un tiret.
  
  if(sol >= 1000) {                       // On personnalise l'affichage en fonction de la mesure, ici si la meseure est supérieure à 1000
  Serial.println("Le capteur n'est pas branche ou hors du sol");
       }
  if(sol < 1000 && sol >= 600) { 
       Serial.println("Le sol est sec, arrose moi vite");
       }
  if(sol < 600 && sol >= 370) {
       Serial.println("Sol humide !"); 
       }
  if(sol < 370) {
       Serial.println("Sol détrempé");
       }




  // Partie du code pour récupérer les données spécifiques au capteur de lumière
  
  int lum= analogRead(LUMPIN);            // On créer un nombre entier qui correspond au chiffre obtenu par le capteur de lumière branché à l'endrois défini au début du code
  Serial.print("Valeur mesuree = ");      // On affiche ce qui est entre ""
  Serial.print(lum); Serial.print(" - "); // On affiche ce chiffre suivi d'un tiret.
  
  if(lum > 0 && lum <= 500) {            // On personnalise l'affichage en fonction de la mesure, ici si la meseure est comprise entre 0 et 500
   Serial.println("Sombre");
  }
  if(lum > 500 && lum <= 900) {
   Serial.println("Lumineux");
  }
  if(lum > 900) {
   Serial.println("Tres lumieux");
  }




  // Partie du code pour récupérer les données spécifiques au capteur de pluie 
  int pluie = analogRead(PLUIEPIN);         // On créer un nombre entier qui correspond au chiffre obtenu par le capteur de pluie branché à l'endrois défini au début du code
  Serial.print("Valeur mesuree = ");        // On affiche ce qui est entre ""
  Serial.print(pluie); Serial.print(" - "); // On affiche ce chiffre suivi d'un tiret.
  
if(pluie >= 1000) {                         // On personnalise l'affichage en fonction de la mesure, ici si la meseure est supérieur à 1000
   Serial.println("Il fait beau");
    }
  if(pluie < 1000 && pluie >= 600) { 
   Serial.println("Bruine");
  }
  if(pluie < 600 && pluie >= 1) {
   Serial.println("Il pleut"); 
  }

  // Délais entre deux mesures, ici 5000 ms, soit 5 secondes
  delay(5000);
}
